﻿--[[
	##AddOn	: CooldownIcons R(evamped)
	##Subfile 	: Options\global_settings.lua
	##Author 	: Hati ( xhatix on wowace.com )
--]]
local CIR = CooldownIconsR
local options = CIR.Options
local db = CIR.db
local media = LibStub("LibSharedMedia-3.0")
local LBF = LibStub("LibButtonFacade", true)
local LCI = LibStub("LibCooldownIcons") -- this is more a personal utility lib (provides some 'extra' functions or extended standard ones)
local icons = CIR.icons

local gDftlT = {
	gFixGCD = true,
    gLagTolerance = false,
}


local function specialHandler(th,v)
	local idb = CIR.db.char.icondb
	if th=='gZoom' then
		local mZoom = LCI:tonumber(v) *.08
		for k,t in pairs(icons) do
			t.texture:SetTexCoord(0.0+mZoom, 1.0-mZoom, 0.0+mZoom, 1.0-mZoom)
			idb[k].iZoom = v
		end
	elseif th=='gRange' then
		for k,t in pairs(icons) do
			if v then
				t:ResetRange()
			else
				t:RangeColoringOff()
			end
			idb[k].iRange = v
		end
	elseif th=='gGrayscale' then
		for k,t in pairs(icons) do
			if v then
				t:ResetGray()
			else
				t:GrayscaleOff()
			end
			idb[k].iGrayscale = v
		end
	elseif th=='gIconSize' then
		for k,t in pairs(icons) do
			t:SetWidth(v)
			t:SetHeight(v)
			t.texture:SetWidth(v)
			t.texture:SetHeight(v)
            if t.glowFrame then
                t.glowFrame.innerGlow:SetPoint("TOPLEFT", t, "TOPLEFT", -v * 0.2, v * 0.2)
                t.glowFrame.innerGlow:SetPoint("BOTTOMRIGHT", t, "BOTTOMRIGHT", v * 0.2, -v*0.2)
                t.glowFrame.outerGlow:SetPoint("TOPLEFT", t, "TOPLEFT", -v * 0.2, v * 0.2)
                t.glowFrame.outerGlow:SetPoint("BOTTOMRIGHT", t, "BOTTOMRIGHT", v * 0.2, -v*0.2)
                t.glowFrame.ants:SetPoint("TOPLEFT", t, "TOPLEFT", -v * 0.2, v * 0.2)
                t.glowFrame.ants:SetPoint("BOTTOMRIGHT", t, "BOTTOMRIGHT", v * 0.2, -v*0.2)
            end
			local mZoom = LCI:tonumber(idb[k].iZoom) *.08
			icons[k].texture:SetTexCoord(0.0+mZoom, 1.0-mZoom, 0.0+mZoom, 1.0-mZoom)
			if LBF then
				LBF:Group('CooldownIcons R'):Skin( unpack(CIR.db.char.BFStyle or { 'Blizzard', 0, nil }))
			end
			idb[k].iIconSize = v
		end
	elseif th=='gAccuracy' then
		for k,t in pairs(icons) do
			idb[k].iAccuracy = v
		end
	--Font
	elseif th=="gFontSize" then
		for obj,t in pairs(icons) do
			t.text:SetFont(media:Fetch("font",media:List('font')[idb[obj].iFontStyle] or "Fonts\\FRIZQT__.TTF"),v,"OUTLINE")
			idb[obj].iFontSize=v
		end
--[[seperate handler setFontStyle, getFontStyle
	elseif th=="gFontStyle" then
		for obj,t in pairs(icons) do
			t.text:SetFont(media:Fetch("font",media:List('font')[v] or "Fonts\\FRIZQT__.TTF"),idb[obj].iFontSize,"OUTLINE")
			idb[obj].iFontStyle=v
		end
]]
	elseif th=="gFontOffsetX" then
		for obj,t in pairs(icons) do
			t.text:SetPoint("CENTER",t:GetName(),"CENTER",v,idb[obj].iFontOffsetY)
			idb[obj].iFontOffsetX=v
		end
	elseif th=="gFontOffsetY" then
		for obj,t in pairs(icons) do
			t.text:SetPoint("CENTER",t:GetName(),"CENTER",idb[obj].iFontOffsetX,v)
			idb[obj].iFontOffsetY=v
		end
	elseif th=="gFontColor" then
		for obj,t in pairs(icons) do
			t.text:SetTextColor(unpack(v or {1.0,1.0,1.0,1.0}))
			idb[obj].iFontColor=v
		end
	--cosmetic types
	elseif th=="gDisplayType" then
		for obj,t in pairs(icons) do
			t.displayType = v
			idb[obj].iDisplayType = v
            CIR:iconConfigHandler(obj,"iDisplayType",v) --woohoo lazy coding
		end
	elseif th=="gTimeFormat" then
		for obj,t in pairs(icons) do
			t.timeFormat = v
			idb[obj].iTimeFormat = v
			--Call request frame, to make individual input and not floating the option frame
			
		end
	end
end


function CIR:getOptionValue(index)
	return CIR.db.char[index[2]][index[3]]
end

function CIR:setOptionValue(index,value)
	CIR.db.char[index[2]][index[3]] = value
	specialHandler(index[3],value)
end



function CIR:getFontStyle(i)
	local _,defaulti = LCI:inTable("Friz Quadrata TT",media:List('font'))
	if i[#i-3] == 'icon_settings' then
		return CIR.db.char.icondb[i[#i-2]][i[#i]] or defaulti
	else
		return CIR.db.char[i[2]][i[3]] or defaulti
	end
end
function CIR:setFontStyle(i,v)
	if i[#i-3] == 'icon_settings' then
		CIR.db.char.icondb[i[#i-2]][i[#i]]=v
		icons[i[#i-2]].text:SetFont(media:Fetch("font",media:List('font')[v] or "Fonts\\FRIZQT__.TTF"),CIR.db.char.icondb[i[#i-2]].iFontSize,"OUTLINE")
	else
		CIR.db.char[i[2]][i[3]]=v
		for k,a in pairs(CIR.db.char.icondb) do
			a.iFontStyle = v
			if icons[k].active then
				icons[k].text:SetFont(media:Fetch("font",media:List('font')[v] or "Fonts\\FRIZQT__.TTF"),a.iFontSize,"OUTLINE")
			end
			--icons[k].text:SetFont((nF_Dir or "Fonts\\FRIZQT__.TTF"),a.iFontSize,"OUTLINE")
		end
	end
end

function CIR:getTextColor(i)
	if i[#i-3] == 'icon_settings' then
		return unpack(CIR.db.char.icondb[i[#i-2]][i[#i]] or {1.0,1.0,1.0,1.0})
	else
		return unpack(CIR.db.char[i[2]][i[3]] or {1.0,1.0,1.0,1.0})
	end
end
function CIR:setTextColor(i,r,g,b,a)
	if i[#i-3] == 'icon_settings' then
		CIR.db.char.icondb[i[#i-2]][i[#i]]={r,g,b,a}
	else
		CIR.db.char[i[2]][i[3]]={r,g,b,a}
		for k,v in pairs(CIR.db.char.icondb) do
			v.iFontColor = {r,g,b,a}
			if icons[k].active then
				icons[k].text:SetTextColor(unpack({r,g,b,a} or {1.0,1.0,1.0,1.0}))
			end
		end
	end
end

function CIR:getRangeColor(i)
	return unpack(CIR.db.char[i[2]][i[3]] or {1.0,0.0,0.0,1.0})
end
function CIR:setRangeColor(i,r,g,b,a)
	CIR.db.char[i[2]][i[3]]={r,g,b,a}
end

CIR.get_global_settings = 
function()
	return {
		--reversion = { type='description', name=CIR.ver, order=1, cmdHidden=true,},
		gIcon={
			type = 'group',
			name = "Icon",
			order = 1,
			args={		
				gAccuracy={
					type='range', name='[Global] Amount of fractional digits',--order=-1,
					desc='Enables fractional digits to keep track of real Cooldowns (ex. Chain Lightning 3.5 cooldown - without it would be rounded to 3)\n0=disable, 1=1 digit after comma(,)\nCurrently only enabled if used Timeformat: 1,3 and 4\nNote: This will also lower/higher the updateFrequency.',
					min=0,max=2,
					step=1,
					get='getOptionValue',
					set='setOptionValue',
				},
				gZoom={
					type='toggle', name='[Global] Toggle Zoom',--order=103,
					desc='Enables/Disables zoom for icons.', width='double',
					get="getOptionValue",
					set="setOptionValue",
				},
				gRange={
					type='toggle', name='[Global] Toggle Range',--order=103,
					desc='Enables/Disables Range-Check',
					get="getOptionValue",
					set="setOptionValue",
				},
				gGrayscale={
					type='toggle', name='[Global] Toggle Grayscale',--order=103,
					desc='Enables/Disables Grayscale',
					get="getOptionValue",
					set="setOptionValue",
				},
				gIconSize={
					type='range', name='[Global] Icon Size',
					desc='Changes the size of icons.',
					min=2,max=124,width='full',
					get="getOptionValue",
					set="setOptionValue",			
				},
				gDisplayType={
					type='select', name='[Global] Display type', order=-2, width='double',
					values = {"Show Always", "On Cooldown only", "If ready"},
					get='getOptionValue',
					set='setOptionValue',
				},
				gTimeFormat={
					type='select', name='[Global] Time Format', order=-1, width='double',
					values= { "Seconds.Miliseconds", "Minute:Seconds", "Minutes", "Seconds[.Miliseconds under X Seconds]" },
					get='getOptionValue',
					set='setOptionValue',
				},
			}
		},
		gFont = {
			type = 'group',
			name = "Font",
			order = 2,
			args={
				gFontSize = {
						type='range', name='[Global] Font size',--order=112,
						desc='Changes the size of the font.',
						min=1,max=32,width='full',
						step=1,
						get='getOptionValue',
						set='setOptionValue',
				},
				gFontStyle={
					type='select',name='[Global] Font',
					values=media:List('font'), style='dropdown',
					get="getFontStyle",
					set="setFontStyle",
				},
				gFontOffsetX={
					type='range', name='[Global] Font X-Offset',--order=112,
					desc='Changes the x-offset of the font to the center of the icon.',
					min=0,max=32,width='full',
					step=1,
					get='getOptionValue',
					set='setOptionValue',
				},
				gFontOffsetY={
					type='range', name='[Global] Font Y-Offset',--order=112,
					desc='Changes the y-offset of the font to the center of the icon.',
					min=0,max=32,width='full',
					step=1,
					get='getOptionValue',
					set='setOptionValue',
				},
				gFontColor={
					type='color', name='[Global] Text Color',order=2,
					desc='Changes the color of the Cooldown Text displayed on Icon.',
					hasAlpha=true,
					get='getTextColor',
					set='setTextColor',
				},
			}
		},
		gMisc = {
			type='group',
			name='Misc',
			order=3,
			args={
				gRangeColor = {
					type='color', name='[Global] Range Color', order=1,
					desc="Changes the coloring of out-of-range or forced range status",
					hasAlpha=true,
					get='getRangeColor',
					set='setRangeColor',
				},
				gFixGCD = { 
					type='toggle', name='[Global] Fix GCD Bug', order= 2,
					desc='Fixes jumps from below 1.5s upward to 1.5s',
					get='getOptionValue',
					set='setOptionValue',
				},
                gLagTolerance = {
                    type='toggle', name='[Global] Experimental Reduced Lag Tolerance', order=3,
                    desc="Enables the timer to be adjusted by ReducedLagTolerance \n Will also force-enable Custom Lag Tolerance!",
                    get='getOptionValue',
                    set='setOptionValue', width='full'
                },
			},
		},
	}
end