--[[
	##AddOn	: CooldownIcons R(evamped)
	##Subfile 	: main.lua
	##Author 	: Hati ( xhatix on wowace.com )
--]]
--##Lib/Ace3 Load
local LCI = LibStub("LibCooldownIcons") -- this is more a personal utility lib (provides some 'extra' functions or extended standard ones)
CooldownIconsR = LibStub("AceAddon-3.0"):NewAddon("CooldownIcons_Revamped","AceConsole-3.0","AceEvent-3.0")
--local LIC = LibStub("LibInternalCooldowns-1.0") --LibInternalCooldowns-1.0
local CIR = CooldownIconsR
--Load ButtonFacade Support,SharedMedia Support
local LBF = LibStub("LibButtonFacade", true)
local media = LibStub("LibSharedMedia-3.0")
CIR.ver = GetAddOnMetadata('CooldownIcons_Revamped_Recode', 'Version')
if CIR.ver == "r61" then CIR.ver = "SVN" end
CIR.events={}

local db
local gDefaults = {
	char = {
		gDebug = false,
		gFont = {
				gFontSize = 12,
				gFontStyle = select(2,LCI:inTable("Friz Quadrata TT",media:List('font'))),
				gFontOffsetX=0,
				gFontOffsetY=1,
				gFontColor = { 1, 1, 1, 1 },
		},
		gIcon = {
			gIconSize = 32,
			gAccuracy = 1,
			gZoom = true,
			gRange = true,
			gGrayscale = true,
			gDisplayType = 1,
			gTimeFormat = 1,
			gTimeFormat4_Border=10,
		},
		gMisc = {
			gRangeColor = {
				1,
				0,
				0,
				1,
			},
			gFixGCD = true,
		},
		icondb = { },
		groupdb = { }
	}
}

function CIR:OnInitialize()
	db = LibStub("AceDB-3.0"):New("CooldownIconsR_DB", gDefaults, true)
	--gDefaults = nil
	self.db = db	
end


function CIR:OnEnable()
	CIR:InitOptions()
	CIR.updateFrequency = 0.0334
	local ACD = LibStub( 'AceConfigDialog-3.0')
	self:RegisterChatCommand("cooldowniconsr", function() ACD:Open(self.name) end)
	self:RegisterChatCommand("cir", function() ACD:Open(self.name) end)
	self:RegisterChatCommand("cooldownicons", function() ACD:Open(self.name) end)
	self:RegisterChatCommand("ci", function() ACD:Open(self.name) end)
	if LBF then
		LBF:Group('CooldownIcons R'):Skin( unpack(CIR.db.char.BFStyle or { 'Blizzard', 0, nil }))
	end
	if LBF then
		LBF:RegisterSkinCallback( 'CooldownIcons R', self.SkinChanged, self)
	end
    CIR:ApplyFixesToScript()
	CIR:ReconstructIcons()
	CIR:RegisterEvent("SPELL_UPDATE_COOLDOWN")
	CIR:RegisterEvent("SPELL_ACTIVATION_OVERLAY_SHOW")
end

function CIR:SkinChanged( SkinID, Gloss, Backdrop, Group, Button, Colors)
	if not CIR.db.char.BFStyle then
		CIR.db.char.BFStyle = { }
	end
	CIR.db.char.BFStyle[1] = SkinID
	CIR.db.char.BFStyle[2] = Gloss
	CIR.db.char.BFStyle[3] = Backdrop
	CIR.db.char.BFStyle[4] = Colors
	for k,v in pairs(CIR.db.char.icondb) do
		if v.iZoom then
			local mZoom = (LCI:tonumber(v.iZoom)) *.08
			CIR.icons[k].texture:SetTexCoord(0.0+mZoom, 1.0-mZoom, 0.0+mZoom, 1.0-mZoom)
		end
	end
end

function CIR:UNIT_INVENTORY_CHANGED(event,arg1)
	if arg1=="player" then
		for id,obj in pairs(self.events[event]) do
            --CIR:UnregisterObjFromAllEvents(obj)
			local script = self.db.char.icondb[obj].script
			self:ProcessScriptForIcon(script,self.icons[obj])
		end
	end
    CIR:SPELL_UPDATE_COOLDOWN("SPELL_UPDATE_COOLDOWN")
end

function CIR:PLAYER_TALENT_UPDATE(event)
	for id,obj in pairs(self.events[event]) do
		local script = self.db.char.icondb[obj].script
        self:wipeCDTables()
		self:ProcessScriptForIcon(script,self.icons[obj],true)
	end
end

function CIR:UNIT_TARGET(event,arg1)
	if arg1=="player" then
		for id,obj in pairs(self.events[event]) do
			local script = self.db.char.icondb[obj].script
			self:ProcessScriptForIcon(script,self.icons[obj])
		end
	end
end

function CIR:UNIT_PET(event, arg1)
	if arg1=="player" then
		for id,obj in pairs(self.events[event]) do
			local script = self.db.char.icondb[obj].script
			self:ProcessScriptForIcon(script,self.icons[obj])
		end
	end
end

function CIR:UNIT_POWER(event,arg1)
	if arg1=="player" or arg1=="target" then
		for id,obj in pairs(self.events[event]) do
			local script = self.db.char.icondb[obj].script
			self:ProcessScriptForIcon(script,self.icons[obj])
		end
	end
end

function CIR:UNIT_AURA(event,arg1)
	--print(arg1.." aura changed.")
	if arg1=="player" or arg1=="target" then
		for id,obj in pairs(self.events[event]) do
			--print("Processing ",id," ",obj)
			local script = self.db.char.icondb[obj].script
			self:ProcessScriptForIcon(script,self.icons[obj])
		end
	end
end

function CIR:UNIT_HEALTH(event,arg1)
	if arg1=="player" or arg1=="target" then
		for id,obj in pairs(self.events[event]) do
			local script = self.db.char.icondb[obj].script
			self:ProcessScriptForIcon(script,self.icons[obj])
		end
	end
end

function CIR:SPELL_UPDATE_USABLE(event,arg1)
    for id,obj in pairs(self.events[event]) do
        local script = self.db.char.icondb[obj].script
        self:ProcessScriptForIcon(script,self.icons[obj])
    end
end

function CIR:PLAYER_REGEN_ENABLED(event)
    self.IsInCombat=false
	for id,obj in pairs(self.events[event]) do
        local script = self.db.char.icondb[obj].script
        self:ProcessScriptForIcon(script,self.icons[obj])
    end
end

function CIR:PLAYER_REGEN_DISABLED(event)
    self.IsInCombat=true
	for id,obj in pairs(self.events[event]) do
        local script = self.db.char.icondb[obj].script
        self:ProcessScriptForIcon(script,self.icons[obj])
    end
end

function CIR:UNIT_COMBO_POINTS(event,unit)
    if unit=="player" then
        for id,obj in pairs(self.events[event]) do
            local script = self.db.char.icondb[obj].script
            self:ProcessScriptForIcon(script,self.icons[obj])
        end
    end
end

function CIR:UNIT_SPELLCAST(unit)
    --print(unit)
    if unit=="target" then
        for id,obj in pairs(CIR.events["UNIT_SPELLCAST"]) do
            local script = CIR.db.char.icondb[obj].script
            CIR:ProcessScriptForIcon(script,CIR.icons[obj])
        end
    end
end

function CIR:GET_ITEM_INFO_RECEIVED()
    for id,obj in pairs(CIR.events["GET_ITEM_INFO_RECEIVED"]) do
        CIR:UnregisterObjFromAllEvents(obj)
        local script = CIR.db.char.icondb[obj].script
        CIR:ProcessScriptForIcon(script,CIR.icons[obj])
    end
end

--DEBUG cmd's
--@debug@
SLASH_ConsoleReloadUI1 = '/rl'
function SlashCmdList.ConsoleReloadUI(msg,editbox)
	ReloadUI()
end
SLASH_CiRStats1 = '/cirstats'
function SlashCmdList.CiRStats(msg,editbox)
	
end
--@debug-end@