--[[
	##AddOn	: CooldownIcons R(evamped)
	##Subfile 	: timer.lua
	##Author  : Hati ( xhatix on wowace.com )
--]]
local CIR = CooldownIconsR
local tinsert = tinsert
local tremove = tremove
local tContains = tContains
local GetTime = GetTime
local LCI = LibStub("LibCooldownIcons") -- extended lua lib 
local function CooldownByCmd(watch,wtype)
	if wtype=='spell' then
		return GetSpellCooldown(watch)
    elseif wtype=='flag-item' then
        return GetInventoryItemCooldown("player",watch)
	else
		return GetItemCooldown(watch)
	end
end
local icondb
CIR.OnCooldown = { }
--start Table
local startT= { }
--duration Table
local durationT = { }

function CIR:wipeCDTables()
    for k,v in pairs(startT) do
        startT[k] = 0
        durationT[k] = 0
    end
end

function CIR:wipeCDEntry(entry)
    durationT[entry]=0
    startT[entry]=0
end
function CIR:wipeDurationEntry(entry)
    durationT[entry]=0
end
function CIR:wipeStartEntry(entry)
    startT[entry]=0
end

--db stores
local gcdFix
local exLagTol
local StartRecOffset


--[[
Hooking GetSpellCooldown in order to achieve 100% accurate cooldowns
]]
local resetOn = {
    --Spell = Buff
    --id's so it's localized
    [23922] = 50227
}

local function GetSpellID(name)
    if not name then return end
    if type(name)=="number" then
        return name
    else
        local v = GetSpellLink(name)
        if v then
            return (select(3,string.find(tostring(v),"Hspell:(%d+)")))
        end
    end
end

local function GetIconsWatching(spell)
    local t = { }
    for icon,obj in pairs(CIR.icons) do
        if obj.active then 
            if spell==obj.watch then
                tinsert(t,icon)
            end
        end
    end
    return t
end

local GetSpellCooldownFix=function(...)
    local spell = ...
    if spell then
        local id = tonumber(GetSpellID(spell) or 0)
        local isBuff = resetOn[id]
        --print(id,isBuff)
        if isBuff and UnitAura("player",GetSpellInfo(isBuff)) then
            local name = GetSpellInfo(id)
            local toStop = GetIconsWatching(name)
            for i,obj in ipairs(toStop) do
                startT[obj]=0
                durationT[obj]=0
                CIR.icons[obj]:SetDisplay(false)
                if tContains(CIR.events["SPELL_UPDATE_COOLDOWN"],obj) then
                    CIR.icons[obj]:SetText("")
                    CIR:ProcessScriptForIcon(CIR.db.char.icondb[obj].script,CIR.icons[obj])
                end
            end
            return 0,0,0
        end
    end
end

hooksecurefunc("GetSpellCooldown",GetSpellCooldownFix)

function CIR:SPELL_ACTIVATION_OVERLAY_SHOW()
    for icon,t in pairs(CIR.icons) do
        if t.type == 'spell' then
            GetSpellCooldownFix(t.watch)
        end
    end
end

function CIR:SPELL_UPDATE_COOLDOWN(event)
	if not icondb then
		icondb = CIR.db.char.icondb
	end
	if not self.OnCooldown then
		self.OnCooldown={}
	end
	gcdFix = CIR.db.char.gMisc.gFixGCD
    exLagTol = CIR.db.char.gMisc.gLagTolerance
    if exLagTol then
        SetCVar("reducedLagTolerance",1)
        StartRecOffset=(tonumber(GetCVar("maxSpellStartRecoveryoffset")) or 0)/1000
    end
	for obj,t in pairs(self.icons) do
		if t.active then
            if not durationT[obj] then durationT[obj]=0 end
            if not startT[obj] then startT[obj]=0 end
            if self.events[event] then
                if tContains(self.events[event],obj) then
                    self:ProcessScriptForIcon(icondb[obj].script,t)
                end
            end
            local watch,wtype = t.watch, t.type
            if not exLagTol then
                if watch and wt~="disabled" then
                    local isRunningCooldown = tContains(self.OnCooldown,obj)
                    local start,duration = CooldownByCmd(watch,wtype)
                    if start and duration then
                        if start==0 or duration==0 then
                            durationT[obj]=0
                            startT[obj]=0
                            t.text:SetText("")
                            t:SetDisplay(false)
                            if not CIR.icons[obj].forcedgray then
                                CIR.icons[obj].texture:SetDesaturated(0)
                            end
                            tDeleteItem(CIR.OnCooldown,obj)
                        elseif gcdFix and duration>1.5 then
                            startT[obj]=start
                            durationT[obj]=duration
                            if icondb[obj].iGrayscale and not t.forcedgray then
                                t.texture:SetDesaturated(1)
                            end
                            if not isRunningCooldown then
                                tinsert(self.OnCooldown,obj)
                                t:SetDisplay(true)
                                t:SetTime(startT[obj],durationT[obj])
                            end
                        elseif not gcdFix then
                            startT[obj]=start
                            durationT[obj]=duration
                            if icondb[obj].iGrayscale and not t.forcedgray then
                                t.texture:SetDesaturated(1)
                            end
                            if not isRunningCooldown then
                                tinsert(self.OnCooldown,obj)
                                t:SetDisplay(true)
                                t:SetTime(startT[obj],durationT[obj])
                            end
                        end
                    end
                end
            else --exLagTol
                if watch and wt~="disabled" then
                    local isRunningCooldown = tContains(self.OnCooldown,obj)
                    local start,duration = CooldownByCmd(watch,wtype)
                    if start and duration then
                        if start==0 or duration==0 then
                            durationT[obj]=0
                            startT[obj]=0
                            t.text:SetText("")
                            t:SetDisplay(false)
                            if not CIR.icons[obj].forcedgray then
                                CIR.icons[obj].texture:SetDesaturated(0)
                            end
                            tDeleteItem(CIR.OnCooldown,obj)
                        elseif gcdFix and duration>1.5 then
                            startT[obj]=start
                            durationT[obj]=duration-StartRecOffset
                            if not isRunningCooldown then
                                tinsert(self.OnCooldown,obj)
                                if icondb[obj].iGrayscale and not t.forcedgray then
                                    t.texture:SetDesaturated(1)
                                end
                                t:SetDisplay(true)
                                t:SetTime(startT[obj],durationT[obj])
                            end
                        elseif not gcdFix then
                            startT[obj]=start
                            durationT[obj]=duration-StartRecOffset
                            if not isRunningCooldown then
                                tinsert(self.OnCooldown,obj)
                                if icondb[obj].iGrayscale and not t.forcedgray then
                                    t.texture:SetDesaturated(1)
                                end
                                t:SetDisplay(true)
                                t:SetTime(startT[obj],durationT[obj])
                            end
                        end
                    end
                end
            end
		end
	end
end

local updaterOnCD --store 
local function updaterFunc(self, elapsed)
	if not CIR.updateFrequency then return end --no frequency (start-up)
	if not self.lastUpdate then
		self.lastUpdate = 0
	end
	self.lastUpdate = self.lastUpdate+elapsed
	while(self.lastUpdate >= CIR.updateFrequency) do
            if CIR.events["SPELL_UPDATE_COOLDOWN"] and GetActiveTalentGroup() then
                for _,iconName in ipairs(CIR.events["SPELL_UPDATE_COOLDOWN"]) do --WORKAROUND for Avenger's Shield and other spells might not firing Spell_Update_Cooldown on going ready.
                    CIR:ProcessScriptForIcon(CIR.db.char.icondb[iconName].script,CIR.icons[iconName])
                end
            end
            if exLagTol then
                SetCVar("reducedLagTolerance",1)
                StartRecOffset=(tonumber(GetCVar("maxSpellStartRecoveryoffset")) or 0)/1000
            end
            updaterOnCD = CIR.OnCooldown
            if #updaterOnCD == 0 then return end
			for num,obj in ipairs(updaterOnCD) do
            --for num,obj in ipairs(CIR.OnCooldown) do
				local icon = CIR.icons[obj]
                local start, duration = CooldownByCmd(icon.watch,icon.type)
                --Cooldown Module
				if GetTime() >= (startT[obj]+durationT[obj]) or (start==0 and duration==0) then
                    startT[obj]=0
                    durationT[obj]=0
					if not icon.forcedgray then
						icon.texture:SetDesaturated(0)
					end
					icon:SetDisplay(false)
					icon.text:SetText("")
					tremove(CIR.OnCooldown,num)
					--self.lastUpdate=self.lastUpdate-CIR.updateFrequency
				else
                    if icondb[obj].iGrayscale and not icon.forcedgray then
                        icon.texture:SetDesaturated(1)
                    end
					if gcdFix then
						if (durationT[obj] == duration or duration==0) then
                            if not exLogTol then
                                durationT[obj]=duration
                            else
                                durationT[obj]=duration-StartRecOffset
                            end
						end
						if (startT[obj] > start and (start ~= GetTime() or duration>1.5) )  then
							startT[obj]=start
						end
					else
                        if not exLogTol then
                            durationT[obj]=duration
                        else
                            durationT[obj]=duration-StartRecOffset
                        end
						startT[obj]=start
					end
		--			local start,duration = CooldownByCmd(icon.watch,icon.type)
					--if GetTime()<(startT[obj]+durationT[obj])  then
						icon:SetDisplay(true)
						icon:SetTime(startT[obj],durationT[obj])
		--[[			elseif GetTime() >= (startT[obj]+durationT[obj]) then
						if not icon.forcedgray then
							icon.texture:SetDesaturated(0)
						end
						icon:SetDisplay(false)
						icon.text:SetText("")
						tremove(CIR.OnCooldown, num)
		]]
                end
                --/Cooldown Module
            end
			--tinsert(threads,0)
        --end
		self.lastUpdate = self.lastUpdate - CIR.updateFrequency
	end
end

local updater = CreateFrame("Frame","CIR_Updater",UIParent)
updater:SetScript("OnUpdate",updaterFunc)


local scriptUpdaterFunc = function(self,elapsed)
    if not CIR.events["CIR_GETTIME"] then return end
    if not CIR.updateFrequency then return else self.freq = 0.334 end --no frequency (start-up)
    if not self.lastUpdate then self.lastUpdate=0 end
    self.lastUpdate=self.lastUpdate+elapsed
    while (self.lastUpdate>self.freq) do
        for _,icon in pairs(CIR.events["CIR_GETTIME"]) do
            CIR:ProcessScriptForIcon(CIR.db.char.icondb[icon].script,CIR.icons[icon])
        end
        self.lastUpdate=self.lastUpdate-0.334
    end
end

local scriptUpdater = CreateFrame("Frame","CIR_ScriptUpdater",nil)
scriptUpdater:SetScript("OnUpdate",scriptUpdaterFunc)
